function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var _classCallCheck = _interopDefault(require('babel-runtime/helpers/classCallCheck'));
var _createClass = _interopDefault(require('babel-runtime/helpers/createClass'));
var _Object$getPrototypeOf = _interopDefault(require('babel-runtime/core-js/object/get-prototype-of'));
var _possibleConstructorReturn = _interopDefault(require('babel-runtime/helpers/possibleConstructorReturn'));
var _inherits = _interopDefault(require('babel-runtime/helpers/inherits'));
var React = _interopDefault(require('react'));
var ReactDOM = _interopDefault(require('react-dom'));

var CEIL = Math.ceil;
var ROUND = Math.round;
var MAX = Math.max;

var WIN = window;
var DOC = window.document;

var Renderer = function () {
  function Renderer() {
    _classCallCheck(this, Renderer);
  }

  _createClass(Renderer, null, [{
    key: "render",
    value: function render(targetNode, config) {
      var contentDocument, hash, iframe, name, onload, ref1, value;
      if (targetNode == null) {
        return Renderer.renderAll();
      }
      if (config == null) {
        config = Renderer.parseConfig(targetNode);
      }
      hash = "#" + Renderer.stringifyQueryString(config);
      iframe = Renderer.createElement("iframe");
      ref1 = {
        allowtransparency: true,
        scrolling: "no",
        frameBorder: 0
      };
      for (name in ref1) {
        value = ref1[name];
        iframe.setAttribute(name, value);
      }
      Renderer.setFrameSize(iframe, [1, 0]);
      iframe.style.border = "none";
      iframe.src = "javascript:0";
      DOC.body.appendChild(iframe);
      onload = function onload() {
        var size;
        size = Renderer.getFrameContentSize(iframe);
        iframe.parentNode.removeChild(iframe);
        Renderer.onceEvent(iframe, "load", function () {
          Renderer.setFrameSize(iframe, size);
        });
        iframe.src = Renderer.BASEURL + "buttons.html" + hash;
        targetNode.parentNode.replaceChild(iframe, targetNode);
      };
      Renderer.onceEvent(iframe, "load", function () {
        var callback;
        if (callback = iframe.contentWindow._) {
          Renderer.onceScriptLoad(callback.$, onload);
        } else {
          onload();
        }
      });
      contentDocument = iframe.contentWindow.document;
      contentDocument.open().write("<!DOCTYPE html><html><head><meta charset=\"utf-8\"><title>" + Renderer.UUID + "</title><link rel=\"stylesheet\" href=\"" + Renderer.BASEURL + "buttons.css\"><script>document.location.hash = \"" + hash + "\";</script></head><body><script src=\"" + Renderer.BASEURL + "index.out.js\"></script></body></html>");
      contentDocument.close();
    }
  }, {
    key: "ceilPixel",
    value: function ceilPixel(px) {
      var devicePixelRatio;
      devicePixelRatio = WIN.devicePixelRatio || 1;
      return (devicePixelRatio > 1 ? CEIL(ROUND(px * devicePixelRatio) / devicePixelRatio * 2) / 2 : CEIL(px)) || 0;
    }
  }, {
    key: "getFrameContentSize",
    value: function getFrameContentSize(iframe) {
      var body, bClientRect, contentDocument, height, html, width;
      contentDocument = iframe.contentWindow.document;
      html = contentDocument.documentElement;
      body = contentDocument.body;
      width = html.scrollWidth;
      height = html.scrollHeight;
      if (body.getBoundingClientRect) {
        body.style.display = "inline-block";
        bClientRect = body.getBoundingClientRect();
        width = MAX(width, Renderer.ceilPixel(bClientRect.width || bClientRect.right - bClientRect.left));
        height = MAX(height, Renderer.ceilPixel(bClientRect.height || bClientRect.bottom - bClientRect.top));
        body.style.display = "";
      }
      return [width, height];
    }
  }, {
    key: "setFrameSize",
    value: function setFrameSize(iframe, size) {
      iframe.style.width = size[0] + "px";
      iframe.style.height = size[1] + "px";
    }
  }, {
    key: "parseConfig",
    value: function parseConfig(anchor) {
      var attribute, config, deprecate, j, len, ref1;
      config = {
        "href": anchor.href,
        "aria-label": anchor.getAttribute("aria-label")
      };
      ref1 = ["icon", "text", "size", "show-count"];
      for (j = 0, len = ref1.length; j < len; j++) {
        attribute = ref1[j];
        attribute = "data-" + attribute;
        config[attribute] = anchor.getAttribute(attribute);
      }
      if (config["data-text"] == null) {
        config["data-text"] = anchor.textContent || anchor.innerText;
      }
      deprecate = function deprecate(oldAttribute, newAttribute, newValue) {
        if (anchor.getAttribute(oldAttribute)) {
          config[newAttribute] = newValue;
          window.console && window.console.warn("GitHub Buttons deprecated `" + oldAttribute + "`: use `" + newAttribute + "=\"" + newValue + "\"` instead. Please refer to https://github.com/ntkme/github-buttons#readme for more info.");
        }
      };
      deprecate("data-count-api", "data-show-count", "true");
      deprecate("data-style", "data-size", "large");
      return config;
    }
  }, {
    key: "onceScriptLoad",
    value: function onceScriptLoad(script, func) {
      var callback = void 0,
          token = void 0;
      token = 0;
      callback = function callback() {
        if (!token && (token = 1)) {
          func();
        }
      };
      Renderer.onEvent(script, "load", callback);
      Renderer.onEvent(script, "error", callback);
      Renderer.onEvent(script, "readystatechange", function () {
        if (!/i/.test(script.readyState)) {
          callback();
        }
      });
    }
  }, {
    key: "createElement",
    value: function createElement(tag) {
      return DOC.createElement(tag);
    }
  }, {
    key: "createTextNode",
    value: function createTextNode(text) {
      return DOC.createTextNode(text);
    }
  }, {
    key: "onEvent",
    value: function onEvent(target, eventName, func) {
      if (target.addEventListener) {
        target.addEventListener("" + eventName, func);
      } else {
        target.attachEvent("on" + eventName, func);
      }
    }
  }, {
    key: "onceEvent",
    value: function onceEvent(target, eventName, func) {
      var _callback = void 0;
      _callback = function callback(event) {
        if (target.removeEventListener) {
          target.removeEventListener("" + eventName, _callback);
        } else {
          target.detachEvent("on" + eventName, _callback);
        }
        return func(event || WIN.event);
      };
      Renderer.onEvent(target, eventName, _callback);
    }
  }, {
    key: "getProto",
    value: function getProto() {
      return (/^http:/.test(DOC.location) ? "http" : "https"
      );
    }
  }, {
    key: "stringifyQueryString",
    value: function stringifyQueryString(obj) {
      var name = void 0,
          params = void 0,
          value = void 0;
      params = [];
      for (name in obj) {
        value = obj[name];
        if (value != null) {
          params.push(Renderer.encodeURIComponent(name) + "=" + Renderer.encodeURIComponent(value));
        }
      }
      return params.join("&");
    }
  }, {
    key: "parseQueryString",
    value: function parseQueryString(str) {
      var j, len, pair, params, ref, ref1;
      params = {};
      ref1 = str.split("&");
      for (j = 0, len = ref1.length; j < len; j++) {
        pair = ref1[j];
        if (!(pair !== "")) {
          continue;
        }
        ref = pair.split("=");
        if (ref[0] !== "") {
          params[Renderer.decodeURIComponent(ref[0])] = Renderer.decodeURIComponent(ref.slice(1).join("="));
        }
      }
      return params;
    }
  }, {
    key: "jsonp",
    value: function jsonp(url, func) {
      var head = void 0,
          script = void 0;
      script = Renderer.createElement("script");
      script.async = true;
      script.src = url + (/\?/.test(url) ? "&" : "?") + "callback=_";
      WIN._ = function (json) {
        WIN._ = null;
        func(json);
      };
      WIN._.$ = script;
      Renderer, onEvent(script, "error", function () {
        WIN._ = null;
      });
      if (script.readyState) {
        Renderer.onEvent(script, "readystatechange", function () {
          if (script.readyState === "loaded" && script.children && script.readyState === "loading") {
            WIN._ = null;
          }
        });
      }
      head = document.getElementsByTagName("head")[0];
      if ("[object Opera]" === {}.toString.call(window.opera)) {
        Renderer.onEvent(DOC, "DOMContentLoaded", function () {
          head.appendChild(script);
        });
      } else {
        head.appendChild(script);
      }
    }
  }, {
    key: "githubPathTest",
    value: function githubPathTest(a) {
      return Renderer.PATH_MATCH.test(a.href);
    }
  }, {
    key: "renderButton",
    value: function renderButton(config) {
      var a = void 0,
          ariaLabel = void 0,
          i = void 0,
          span = void 0;
      a = Renderer.createElement("a");
      a.href = config.href;
      if (!/\.github\.com$/.test("." + a.hostname)) {
        a.href = "#";
        a.target = "_self";
      } else if (Renderer.githubPathTest(a)) {
        a.target = "_top";
      }
      a.className = "btn";
      if (ariaLabel = config["aria-label"]) {
        a.setAttribute("aria-label", ariaLabel);
      }
      i = a.appendChild(Renderer.createElement("i"));
      i.className = Renderer.ICON_CLASS + " " + (config["data-icon"] || Renderer.ICON_CLASS_DEFAULT);
      i.setAttribute("aria-hidden", "true");
      a.appendChild(Renderer.createTextNode(" "));
      span = a.appendChild(Renderer.createElement("span"));
      span.appendChild(Renderer.createTextNode(config["data-text"] || ""));
      return DOC.body.appendChild(a);
    }
  }, {
    key: "renderCount",
    value: function renderCount(button) {
      var api, href, match, property;
      if (button.hostname !== "github.com") {
        return;
      }
      match = button.pathname.replace(/^(?!\/)/, "/").match(Renderer.COUNT_MATCH);
      if (!(match && !match[6])) {
        return;
      }
      if (match[2]) {
        href = "/" + match[1] + "/" + match[2];
        api = "/repos" + href;
        if (match[3]) {
          property = "subscribers_count";
          href += "/watchers";
        } else if (match[4]) {
          property = "forks_count";
          href += "/network";
        } else if (match[5]) {
          property = "open_issues_count";
          href += "/issues";
        } else {
          property = "stargazers_count";
          href += "/stargazers";
        }
      } else {
        api = "/users/" + match[1];
        property = "followers";
        href = "/" + match[1] + "/" + property;
      }
      Renderer.jsonp(Renderer.GITHUB_API_BASEURL + api, function (json) {
        var a, data, span;
        if (json.meta.status === 200) {
          data = json.data[property];
          a = Renderer.createElement("a");
          a.href = "https://github.com" + href;
          a.className = "social-count";
          a.setAttribute("aria-label", data + " " + property.replace(/_count$/, "").replace("_", " ") + " on GitHub");
          a.appendChild(Renderer.createElement("b"));
          a.appendChild(Renderer.createElement("i"));
          span = a.appendChild(Renderer.createElement("span"));
          span.appendChild(Renderer.createTextNode(("" + data).replace(/\B(?=(\d{3})+(?!\d))/g, ",")));
          button.parentNode.insertBefore(a, button.nextSibling);
        }
      });
    }
  }, {
    key: "renderFrameContent",
    value: function renderFrameContent(hash) {
      var config = Renderer.parseQueryString(hash.replace(/^#/, ""));
      var button;
      if (!config) {
        return;
      }
      if (/^large$/i.test(config["data-size"])) {
        DOC.body.className = "large";
      }
      button = Renderer.renderButton(config);
      if (/^(true|1)$/i.test(config["data-show-count"])) {
        Renderer.renderCount(button);
      }
    }
  }, {
    key: "renderAll",
    value: function renderAll() {
      var anchor, anchors, j, k, len, len1, ref1;
      anchors = [];
      if (DOC.querySelectorAll) {
        anchors = DOC.querySelectorAll("a." + Renderer.BUTTON_CLASS);
      } else {
        ref1 = DOC.getElementsByTagName("a");
        for (j = 0, len = ref1.length; j < len; j++) {
          anchor = ref1[j];
          if (~(" " + anchor.className + " ").replace(/[ \t\n\f\r]+/g, " ").indexOf(" " + Renderer.BUTTON_CLASS + " ")) {
            anchors.push(anchor);
          }
        }
      }
      for (k = 0, len1 = anchors.length; k < len1; k++) {
        anchor = anchors[k];
        Renderer.render(anchor);
      }
    }
  }, {
    key: "defer",
    value: function defer(func) {
      var _callback2, token;
      if (/m/.test(DOC.readyState) || !/g/.test(DOC.readyState) && !DOC.documentElement.doScroll) {
        WIN.setTimeout(func);
      } else {
        if (DOC.addEventListener) {
          token = 0;
          _callback2 = function callback(e) {
            if (!token && (token = 1)) {
              func();
            }
          };
          Renderer.onceEvent(DOC, "DOMContentLoaded", _callback2);
          Renderer.onceEvent(WIN, "load", _callback2);
        } else {
          _callback2 = function callback() {
            if (/m/.test(DOC.readyState)) {
              DOC.detachEvent("onreadystatechange", _callback2);
              func();
            }
          };
          DOC.attachEvent("onreadystatechange", _callback2);
        }
      }
    }
  }]);

  return Renderer;
}();

Renderer.UUID = "faa76404-3b97-5585-b449-4bc51338fbd1";
Renderer.BUTTON_CLASS = "github-button";
Renderer.ICON_CLASS = "octicon";
Renderer.ICON_CLASS_DEFAULT = Renderer.ICON_CLASS + "-mark-github";
Renderer.GITHUB_API_BASEURL = "https://api.github.com";
Renderer.DOMAIN = "buttons.github.io";
Renderer.BASEURL = Renderer.getProto() + "://" + Renderer.DOMAIN + "/";
Renderer.COUNT_MATCH = /^\/([^\/?#]+)(?:\/([^\/?#]+)(?:\/(?:(subscription)|(fork)|(issues)|([^\/?#]+)))?)?(?:[\/?#]|$)/;
Renderer.PATH_MATCH = /^https?:\/\/((gist\.)?github\.com\/[^\/?#]+\/[^\/?#]+\/archive\/|github\.com\/[^\/?#]+\/[^\/?#]+\/releases\/download\/|codeload\.github\.com\/)/;
Renderer.decodeURIComponent = window.decodeURIComponent;
Renderer.encodeURIComponent = window.encodeURIComponent;

var Base = function () {
  function Base() {
    _classCallCheck(this, Base);

    if (typeof window === "undefined") {
      throw new Error("Build to run only in browser environment.");
    } else {
      this.init();
    }
  }

  _createClass(Base, [{
    key: "init",
    value: function init() {
      var self = this;
      if (typeof define === "function" && define.amd) {
        define([], { render: Renderer.render, Renderer: Renderer });
      } else {
        if (!{}.hasOwnProperty.call(document, "currentScript") && document.currentScript && delete document.currentScript && document.currentScript) {
          Renderer.BASEURL = document.currentScript.src.replace(/[^\/]*([?#].*)?$/, "");
        }
        if (document.title === Renderer.UUID) {
          Renderer.renderFrameContent(document.location.hash);
        } else {
          Renderer.defer(Renderer.renderAll);
        }
      }
    }
  }]);

  return Base;
}();

var render$1 = Renderer.render;

var GitHubButton = function (_React$Component) {
  _inherits(GitHubButton, _React$Component);

  function GitHubButton() {
    _classCallCheck(this, GitHubButton);

    return _possibleConstructorReturn(this, (GitHubButton.__proto__ || _Object$getPrototypeOf(GitHubButton)).apply(this, arguments));
  }

  _createClass(GitHubButton, [{
    key: "render",
    value: function render$1() {
      return React.createElement("span", null, React.createElement("a", this.props, this.props.children));
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      render$1(this._ = ReactDOM.findDOMNode(this).firstChild);
    }
  }, {
    key: "componentWillUpdate",
    value: function componentWillUpdate() {
      ReactDOM.findDOMNode(this).replaceChild(this._, ReactDOM.findDOMNode(this).firstChild);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      render$1(this._ = ReactDOM.findDOMNode(this).firstChild);
    }
  }]);

  return GitHubButton;
}(React.Component);

window.GitHubButton = GitHubButton || null;

var base = new Base();
//# sourceMappingURL=index.js.map
